

window.onload = function () {

  var searchParams = new URLSearchParams(window.location.search);

  var url = decodeURIComponent(searchParams.get('url'))
  var token = searchParams.get('token')
  var arraybuffer = null;
  let xhr = new XMLHttpRequest();
  xhr.responseType = 'arraybuffer';
  xhr.open('GET', url);
  xhr.setRequestHeader("token", token);
  xhr.setRequestHeader("Authorization", `Bearer ${token}`);
  xhr.send();

  xhr.onload = function () {
    if (xhr.status != 200) {
      alert(`Error ${xhr.status}: ${xhr.statusText}`);
    } else {
      arraybuffer = new Uint8Array(xhr.response);
      console.log(xhr, arraybuffer)

      if (arraybuffer.length > 100) {
        for (let index = 0; index < 100; index++) {
          arraybuffer[index] = arraybuffer[index] ^ 1;
        }
      }
      console.log(arraybuffer)
      init()
    }
  };

  var pdfDoc = null,
    scale = 1,
    $readPPT = document.querySelector(".read-ppt"),
    resizeTimeout;

  function initDom(num) {
    let fragement = document.createDocumentFragment()
    for (let i = 1; i <= num; i++) {
      let canvas = document.createElement('canvas')
      canvas.setAttribute('class', 'item')
      ctx = canvas.getContext('2d');
      pdfDoc.getPage(i).then(function (page) {
        console.log(i)
        var desireWidth = $readPPT.clientWidth - 5,
          viewport = page.getViewport(scale),
          desireScale = desireWidth / viewport.width,
          scaleViewPort = page.getViewport(desireScale);
        canvas.height = scaleViewPort.height;
        canvas.width = scaleViewPort.width;
        // $readPPT.css("padding-bottom", canvas.height / canvas.width * $readPPT.clientWidth);
        var renderContext = {
          canvasContext: canvas.getContext('2d'),
          viewport: scaleViewPort
        };
        page.render(renderContext);

        // renderTask.promise.then(function () {
        //   pageRendering = false;
        //   document.querySelector(".ppt-pager").style.display = 'block';
        //   // $loadingEle.style.display = 'none';
        //   if (pageNumPending !== null) {
        //     renderPage(pageNumPending);
        //     pageNumPending = null;
        //   }
        // });
      })
      fragement.appendChild(canvas)
      document.querySelector('.read-ppt').appendChild(fragement)
    }
  }

  function init() {
    if (document.querySelector(".read-ppt #canvas")) {
      pdfjsLib.getDocument(arraybuffer).then(function (pdfDoc_) {
        pdfDoc = pdfDoc_;
        initDom(pdfDoc.numPages)
      },
        function error(e) {
          alert(e.message);
        });
      window.onresize = function () {
        if (pdfDoc) {
          clearTimeout(resizeTimeout);
          resizeTimeout = setTimeout(function () {
            initDom(pdfDoc.numPages)
          },
            200);
        }
      }
    }
  }

}
