window.onload = function() {
	// console.log(JSEncrypt)
	// console.log(window.location)
	var searchParams = new URLSearchParams(window.location.search); 
	
	const token = searchParams.get('token');
	// console.log(getUrlParam('token'));
	const m3u8Url = decodeURIComponent(searchParams.get('m3u8Url'))
	const name = decodeURIComponent(searchParams.get('name')) || '视频预览'
	const productCode = searchParams.get('productCode')
	const video = document.querySelector('#video')
	document.title = name;
	// console.log(video);
	//判断下是否支持
	const isSupportedVideo = () => {
	  if (Hls.isSupported()) {
	      createHlsVideo();
	  }  else {
		  console.log('不支持hls')
	  }
	}
	const createHlsVideo = () => {
	  class loader extends Hls.DefaultConfig.loader {
	    constructor(config) {
	      super(config);
	    }
	
	    load(context, config, callbacks) {
	      const { type } = context;
	      //保存原来的onSuccess方法
	      const oriSuccess = callbacks.onSuccess;
	      //修改onSuccess方法，实现对m3u8内容的解密
	      callbacks.onSuccess = (response, stats, context1, networkDetails) => {
	        if (type === "manifest") {
	          //在这里实现对m3u8内容解密
	          let content = aesDecrypt(response.data);
	          if (content.indexOf(",IV=") < 0) {
	            //linux切片有问题,少了IV这边补上去
	            content = content.replace(
	              /(#EXT-X-KEY:METHOD=AES-128,URI="key\?fileId=\d+")/,
	              "$1,IV=0x00000000000000000000000000000000"
	            );
	          }
	          response.data = content;
	        }
	        oriSuccess(response, stats, context1, networkDetails);
	      };
	      super.load(context, config, callbacks);
	    }
	  }
	
	  //请求m3u8文件、key文件、ts文件带上token,请求key时得到fileId,后续请求ts时带上
	  const xhrSetup = (xhr, url) => {
	    if (url.indexOf("hls/key") > 0) {
	      tsParam = url.substr(url.indexOf("?"));
	    } else if (url.endsWith(".ts") > 0) {
	      xhr.open("GET", url + tsParam, true);
	    }
	
	    xhr.setRequestHeader("token", token);
	    if (productCode != "") {
	      xhr.setRequestHeader("courseId", productCode);
	    }
	    xhr.setRequestHeader("Authorization", `Bearer ${token}`);
	  };
	
	  hls = new Hls({ loader: loader, xhrSetup: xhrSetup });
	  hls.loadSource(m3u8Url);
	  hls.attachMedia(video);
	  hls.on(Hls.Events.MANIFEST_PARSED, () => {console.log('m3u8') });
	  hls.on(Hls.Events.ERROR, (event, data) => {
			console.log(event,data)
	    if (data.details === Hls.ErrorDetails.MANIFEST_LOAD_ERROR) {
	      if (data.response.code !== 200) {
	        $message({
	          message: "视频正在转码中，请稍后再查看",
	          type: "warning",
	        });
	      }
	    }
	  });
	  //key二次解密
	  let flag = false;
	  hls.on(Hls.Events.KEY_LOADED, (event, data) => {
	    if (!flag && data.frag && data.frag.levelkey && data.frag.levelkey.key) {
	      let array = data.frag.levelkey.key;
	      //转成字符串
	      // let key = String.fromCharCode.apply(null, array);
	      let key = String.fromCharCode(...array);
	      //解密
	      key = getDecrypt(key);
	      //字符串转Uint8Array
	      let arr = [];
	      for (let i = 0, j = key.length; i < j; ++i) {
	        arr.push(key.charCodeAt(i));
	      }
	      data.frag.levelkey.key = new Uint8Array(arr);
	      flag = true;
	    }
	  });
	}
	
	isSupportedVideo()
}
